# frozen_string_literal: true

class GreetLocally::Translator
  def initialize(ip_address)
    @geolocation_url = "https://ipinfo.io/#{ip_address}" #Gets IP for user
    @language_url = "https://restcountries.eu/rest/v2/alpha"
  end

  def process
    say_hi(language)
  end
  
  private

  attr_reader :geolocation_url, :language_url

  def say_hi(language = "english")
    case language.downcase
    when "spanish"
    "Hola Mundo!"
    when "chinese"
    "你好，世界!"
    when "japanese"
    "こんにちは世界!"
    when "german"
    "Hallo Welt!"
    when "hindi"
    "नमस्ते दुनिया!"
    when "russian"
    "Привет мир!"
    else
    "Hello world!"
    end
  end

  def location
    response = Net::HTTP.get(URI.parse(geolocation_url))
    JSON.parse(response)["country"].downcase
  end

  def language
    response = Net::HTTP.get(URI.parse("#{language_url}/#{location}"))
    JSON.parse(response)["languages"][0]["name"].downcase
  end
end
